//+------------------------------------------------------------------+
//|                                                  RandomV2.mq4    |
//|                                            Copyright  2007, mvp |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, mvp"
#property link      "mvp@gala.net"
#include <stdlib.mqh>

string currencys[] = {"USDCHF", "GBPUSD", "EURUSD", "USDJPY", "AUDUSD", "USDCAD", "EURGBP", 
   "EURCHF", "EURJPY", "GBPJPY", "GBPCHF", "EURAUD", "GOLD", "NZDUSD", "CHFJPY", "EURCAD", 
   "GBPAUD", "GBPCAD", "AUDCAD", "SILVER", "GE", "TWX", "C", "CSCO", "IBM", "GM", "INTC", "MSFT",
   "NOKIA", "YHOO", "MOT", "MMM", "AMZN", "DELL", "MO", "ORCL", "DJ7U", "YM7U", "@NQ7U", "@ES7U",
   "@SP7U", "ECS7U", "BPS7U", "JYS7U", "SFS7U", "CL7X", "CL7V", "KC7U", "@NG7U", "NG7U", "@NG7V",
   "NG7V"};
//+---------------------------------------------------------------------------------------------+
int init()
  {
   MathSrand(TimeLocal());
   Print(GlobalVariableGet("RandomV2_State"));
   if (!GlobalVariableCheck("RandomV2_State")) {
      GlobalVariableSet("RandomV2_State", 0);
   }
   if ((GlobalVariableGet("RandomV2_State") == 1) && (GetOrderCount() == 0)) 
      GlobalVariableSet("RandomV2_State", 0);
   if (!GlobalVariableCheck("RandomV2_OrdCount")) {
      GlobalVariableSet("RandomV2_OrdCount", ToInt2(MathRand() % (ArraySize(currencys) - 6) + 
         6));
   }
   return(0);
  }
//+------------------------------------------------------------+
bool isNewBar() {
   static datetime prevtime = 0;
   static int _= 0;
   if (prevtime == iTime(Symbol(), PERIOD_M1, 0)) return(false);
   prevtime = iTime(Symbol(), PERIOD_M1, 0);
   _= (_ + 1) % 11;
   Print("Time Left: ", 11 -_);
   return (_ == 0);
}
//-----------------------
int GetOrderCount() {
   return(OrdersTotal());
}
//---------------------------------------------------------------------------------------------
void OpenOrder(string sym) {
   double price, lots;
   int op;
   int sl;
   Print(sym);
   if (MarketInfo(sym, MODE_TRADEALLOWED) == 1) {
      if ((GetOrderCount() < GlobalVariableGet("RandomV2_OrdCount")) && CheckOpenSym(sym)) {
         RefreshRates();
         op = MathRand() % 6;
         switch (op) {
            case OP_BUY : 
               price = MarketInfo(sym, MODE_ASK);
               break;
            case OP_SELL: 
               price = MarketInfo(sym, MODE_BID);
               break;
            case OP_BUYLIMIT :
               price = MarketInfo(sym, MODE_ASK) - ToDouble(2 * MarketInfo(sym, MODE_STOPLEVEL), 
                  sym);
               break;
            case OP_SELLLIMIT :
               price = MarketInfo(sym, MODE_BID) + ToDouble(2 * MarketInfo(sym, MODE_STOPLEVEL),
                  sym);
               break;
            case OP_BUYSTOP :
               price = MarketInfo(sym, MODE_ASK) + ToDouble(2 * MarketInfo(sym, MODE_STOPLEVEL),
                  sym);
               break;
            case OP_SELLSTOP : 
               price = MarketInfo(sym, MODE_BID) - ToDouble(2 * MarketInfo(sym, MODE_STOPLEVEL),
                  sym);   
         }
         lots = GetLots(sym, op);
         
         if (lots != 0){
               sl = GetStopLoss(sym, lots);
             if (op % 2 == 0) myOrderSend(sym, op, lots, price,  0, price - 
            ToDouble(sl, sym), price + ToDouble(sl << 1, sym), '', 0, 0, Purple); else 
            myOrderSend(sym, op, lots, price, 0, price + ToDouble(sl, sym), price - 
            ToDouble(sl << 1, sym), '', 0, 0, Maroon);
        }
      }
   }
   if (GetOrderCount() >= GlobalVariableGet("RandomV2_OrdCount")) 
      GlobalVariableSet("RandomV2_State", 1);
}
//----------------------------------------------------------------------------------------------
int myOrderSend(string symbol, int cmd, double volume, double price, int slippage, 
   double stoploss, double takeprofit, string comment = "", int magic = 0, datetime expiration = 
   0, color arrow_color = CLR_NONE) {
   string mycomment, op;
   int err = OrderSend(symbol, cmd, volume, NormDouble(price, symbol), slippage, stoploss,
      takeprofit, comment, magic, expiration, arrow_color);
   if (err < 0) {
      switch (cmd) {
         case OP_BUY :
            mycomment = " Buy";
            op        = "OP_BUY";
            break;
          case OP_SELL :
            mycomment = " Sell";
            op        = "OP_SELL";
            break;
          case OP_BUYLIMIT : 
            mycomment = " BuyLimit";
            op        = "OP_BUYLIMIT";
            break;
         case OP_SELLLIMIT  : 
            mycomment = " SellLimit";
            op        = "OP_SELLLIMIT";
            break;
         case OP_SELLSTOP : 
            mycomment = " SellStop";
            op        = "OP_SELLSTOP";
            break;
         case OP_BUYSTOP :
            mycomment = " BuyStop";
            op        = "OP_BUYSTOP";
      }
      LogErrors(mycomment + "(" + symbol + ", " + op + ", " + volume + ", " + NormDouble(price, 
         symbol) + ", " + slippage + ", " + NormDouble(stoploss, symbol) + ", " + 
         NormDouble(takeprofit, symbol) + ", " + comment + ", " + magic + ", " + expiration + 
         ", " + ColorToStr(arrow_color) + ")");
      RefreshRates();
      LogErrors(" Bid = " + MarketInfo(symbol, MODE_BID));
      LogErrors(" Ask = " + MarketInfo(symbol, MODE_ASK));
   }
}
//-----------------------------------------------------------------------------------------------
string ColorToStr(color aColor){
   color tColor[] = {Black, DarkGreen, DarkSlateGray, Olive, Green, Teal, Navy, Purple, Maroon, 
      Indigo, MidnightBlue, DarkBlue, DarkOliveGreen, SaddleBrown, ForestGreen, OliveDrab, 
      SeaGreen, DarkGoldenrod, DarkSlateBlue, Sienna, MediumBlue, Brown, DarkTurquoise, DimGray,
      LightSeaGreen, DarkViolet, FireBrick, MediumVioletRed, MediumSeaGreen, Chocolate, Crimson, 
      SteelBlue, Goldenrod, MediumSpringGreen, LawnGreen, CadetBlue, DarkOrchid, YellowGreen, 
      LimeGreen, OrangeRed, DarkOrange, Orange, Gold, Yellow, Chartreuse, Lime, SpringGreen, Aqua,
      DeepSkyBlue, Blue, Magenta, Red, Gray, SlateGray, Peru, BlueViolet, LightSlateGray, 
      DeepPink, MediumTurquoise, DodgerBlue, Turquoise, RoyalBlue, SlateBlue, DarkKhaki,
      IndianRed, MediumOrchid, GreenYellow, MediumAquamarine, DarkSeaGreen, Tomato, RosyBrown, 
      Orchid, MediumPurple, PaleVioletRed, Coral, CornflowerBlue, DarkGray, SandyBrown, 
      MediumSlateBlue, Tan, DarkSalmon, BurlyWood, HotPink, Salmon, Violet, LightCoral, SkyBlue, 
      LightSalmon, Plum, Khaki, LightGreen, Aquamarine, Silver, LightSkyBlue, LightSteelBlue, 
      LightBlue, PaleGreen, Thistle, PowderBlue, PaleGoldenrod, PaleTurquoise, LightGray, Wheat,
      NavajoWhite, Moccasin, LightPink, Gainsboro, PeachPuff, Pink, Bisque, LightGoldenrod, 
      BlanchedAlmond, LemonChiffon, Beige, AntiqueWhite, PapayaWhip, Cornsilk, LightYellow, 
      LightCyan, Linen, Lavender, MistyRose, OldLace, WhiteSmoke, Seashell, Ivory, Honeydew,
      AliceBlue, LavenderBlush, MintCream, Snow, White};  
   string tName[] = {"Black", "DarkGreen", "DarkSlateGray", "Olive", "Green", "Teal", "Navy", 
      "Purple", "Maroon", "Indigo", "MidnightBlue", "DarkBlue", "DarkOliveGreen", "SaddleBrown", 
      "ForestGreen", "OliveDrab", "SeaGreen", "DarkGoldenrod", "DarkSlateBlue", "Sienna", 
      "MediumBlue", "Brown", "DarkTurquoise", "DimGray", "LightSeaGreen", "DarkViolet", 
      "FireBrick", "MediumVioletRed", "MediumSeaGreen", "Chocolate", "Crimson", "SteelBlue", 
      "Goldenrod", "MediumSpringGreen", "LawnGreen", "CadetBlue", "DarkOrchid", "YellowGreen", 
      "LimeGreen", "OrangeRed", "DarkOrange", "Orange", "Gold", "Yellow", "Chartreuse", "Lime", 
      "SpringGreen", "Aqua", "DeepSkyBlue", "Blue", "Magenta", "Red", "Gray", "SlateGray", "Peru", 
      "BlueViolet", "LightSlateGray", "DeepPink", "MediumTurquoise", "DodgerBlue", "Turquoise", 
      "RoyalBlue", "SlateBlue", "DarkKhaki", "IndianRed", "MediumOrchid", "GreenYellow", 
      "MediumAquamarine", "DarkSeaGreen", "Tomato", "RosyBrown", "Orchid", "MediumPurple", 
      "PaleVioletRed", "Coral", "CornflowerBlue", "DarkGray", "SandyBrown", "MediumSlateBlue", 
      "Tan", "DarkSalmon", "BurlyWood", "HotPink", "Salmon", "Violet", "LightCoral", "SkyBlue", 
      "LightSalmon", "Plum", "Khaki", "LightGreen", "Aquamarine", "Silver", "LightSkyBlue", 
      "LightSteelBlue", "LightBlue", "PaleGreen", "Thistle", "PowderBlue", "PaleGoldenrod", 
      "PaleTurquoise", "LightGray", "Wheat", "NavajoWhite", "Moccasin", "LightPink", "Gainsboro",
      "PeachPuff", "Pink", "Bisque", "LightGoldenrod", "BlanchedAlmond", "LemonChiffon", "Beige", 
      "AntiqueWhite", "PapayaWhip", "Cornsilk", "LightYellow", "LightCyan", "Linen", "Lavender", 
      "MistyRose", "OldLace", "WhiteSmoke", "Seashell", "Ivory", "Honeydew", "AliceBlue", 
      "LavenderBlush", "MintCream", "Snow", "White"};
      for (int _ = 0; _ < ArraySize(tColor); _++) if (aColor == tColor[_]) return(tName[_]);
      return("Unknown");                                                       
}
//---------------------------------------------------------------------------------------------
double GetLots(string sym, int op) {
   double Margin = AccountBalance() / GlobalVariableGet("RandomV2_OrdCount");
   double Margin1L = MarketInfo(sym, MODE_MARGINREQUIRED);
   double ltmp, minstep = MarketInfo(sym, MODE_LOTSTEP);
   int digit, _, op1;
   if (Margin > AccountFreeMargin()) Margin = AccountFreeMargin();
   digit = GetCountNumberAfterComma(MarketInfo(sym, MODE_LOTSTEP));
   _ = digit;
   ltmp = NormalizeDouble(Margin / Margin1L, digit);
   if (ltmp < MarketInfo(sym, MODE_MINLOT)) ltmp = MarketInfo(sym, MODE_MINLOT);
   while (digit > 0) {
      ltmp *= 10;
      digit--;
      minstep *= 10;
   }
   digit = _;
   ltmp = ltmp - ToInt2(ltmp) % ToInt2(minstep);
   while (_ > 0) {
      ltmp /= 10;
      _--;
   }
   if (ltmp > MarketInfo(sym, MODE_MAXLOT)) ltmp = MarketInfo(sym, MODE_MAXLOT);
   if (ltmp < MarketInfo(sym, MODE_MINLOT)) ltmp = 0;
   if ((op == OP_BUY) || (op == OP_BUYLIMIT) || (op == OP_BUYSTOP)) op1 = OP_BUY; else op1 = 
      OP_SELL;
   while (ltmp >= MarketInfo(sym, MODE_MINLOT) && ((AccountFreeMarginCheck(sym, op1, ltmp) <= 
      0) || (GetLastError() == 134))) {
         ltmp -= MarketInfo(sym, MODE_LOTSTEP);
         Print("Lots:", ltmp);
         if (ltmp < MarketInfo(sym, MODE_MINLOT)) break;
      }
   if (ltmp < MarketInfo(sym, MODE_MINLOT)) ltmp = 0;
   return (NormalizeDouble(ltmp, digit));  
}
//------------------------
int ToInt2(double var) {
   return(MathRound(var));
}
//----------------------------------------
int GetCountNumberAfterComma(double var) {
   int _= 0;
   while (MathRound(var) != var) {
      _++;
      var *= 10;
   }
   return (_);
}
//----------------------------------------------
void LogErrors(string myComment) {
   int err = GetLastError();
   Print(myComment);
   if (err != 0) {
      Print("ErrCode: ", err);
      Print("ErrDesc: ", ErrorDescription(err));
   }
}
//-------------------------------------------------------------
double NormDouble(double var, string sym) { 
   return (NormalizeDouble(var, MarketInfo(sym, MODE_DIGITS)));
}
//--------------------------------------------
double ToDouble(int var, string sym) {
   return (var * MarketInfo(sym, MODE_POINT));
}
//----------------------------------------------------------------------------------------------
int GetPosWithMaxLoss() {
   double min = AccountBalance() * 100;
   int ticket = -1;
   bool pending = false;
   for (int _= OrdersTotal() - 1; _>= 0; _--) if (OrderSelect(_, SELECT_BY_POS, MODE_TRADES) &&
      ((OrderProfit() < min) || (OrderType() > OP_SELL))) {
      if ((OrderType() > OP_SELL) && ((-OrderOpenTime() > min) || (!pending))) {
         pending = true;
         min = -OrderOpenTime();
         ticket = OrderTicket();
      } else if (OrderType() <= OP_SELL) {
         min = OrderProfit();
         ticket = OrderTicket();
      }
   }
   if (ticket != -1){
      OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);
      Print(OrderSymbol(), " - ", OrderProfit()); 
   } else Print(" ");
   return(ticket);
}
//---------------------------------------------------------------------------------------------
bool CheckOpenSym(string sym) {
   for (int _= OrdersTotal() - 1; _>= 0; _--) if (OrderSelect(_, SELECT_BY_POS, MODE_TRADES) &&
      OrderSymbol() == sym) return (false);
   return (true);
}
//--------------------------------------------------------------------------------------
int GetStopLoss(string sym, double lots) {
   int PointToTrade = ToInt2(AccountBalance() / GlobalVariableGet("RandomV2_OrdCount") / 
      MarketInfo(sym, MODE_TICKVALUE) / lots);
   if (PointToTrade < MarketInfo(sym, MODE_STOPLEVEL)) PointToTrade = MarketInfo(sym, 
      MODE_STOPLEVEL);
   Print(sym, " - ", PointToTrade);
   return(PointToTrade);
}
//-------------------------------------------------------------------------------------------
int start(){
   double state, price;
   string sym;
   int ticket;
   if (isNewBar()) {
      if (AccountProfit() > AccountBalance() / 10) GlobalVariableSet("RandomV2_State", 2);
      state = GlobalVariableGet("RandomV2_State");
      Print("State: ", state);
      if (state == 0) {
         sym = currencys[MathRand() % ArraySize(currencys)];
         OpenOrder(sym);
         return (0);
      }
      if (GetOrderCount() == 0) {
         GlobalVariableSet("RandomV2_State", 0);
         GlobalVariableSet("RandomV2_OrdCount", ToInt2(MathRand()) % (ArraySize(currencys) - 6) + 
            6);
         return(0);
      }
      ticket = GetPosWithMaxLoss();
      if (ticket != -1) {
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES) && (MarketInfo(OrderSymbol(),
            MODE_TRADEALLOWED) == 1) && (OrderType() > OP_SELL)) {
            if (iTime(Symbol(), PERIOD_M1, 0) - OrderOpenTime() > 86400) {
               OrderDelete(ticket, SkyBlue);
               GlobalVariableSet("RandomV2_State", 0);       
            }     
         }
      }
   }
   return(0);
}
//+------------------------------------------------------------------+